"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactLifecyclesCompat = require("react-lifecycles-compat");

var _rcTreeSelect = _interopRequireWildcard(require("rc-tree-select"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var SubjectComponents =
/*#__PURE__*/
function (_React$Component) {
  _inherits(SubjectComponents, _React$Component);

  function SubjectComponents(props) {
    var _this;

    _classCallCheck(this, SubjectComponents);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(SubjectComponents).call(this, props));
    _this.onChange = _this.onChange.bind(_assertThisInitialized(_this));
    _this.onClick = _this.onClick.bind(_assertThisInitialized(_this));
    _this.onTreeSelectChange = _this.onTreeSelectChange.bind(_assertThisInitialized(_this));
    _this.state = {
      activeItem: null,
      activeKey: '',
      treeList: [],
      value: ''
    };
    return _this;
  }

  _createClass(SubjectComponents, [{
    key: "onChange",
    value: function onChange(event) {
      this.setState({
        value: event.target.value
      });
    }
  }, {
    key: "onClick",
    value: function onClick(item) {
      var activeKey = item.id;
      var treeList = [];
      var activeItem = null;

      if (item.id === this.state.activeKey) {
        activeKey = '';
      } else {
        activeItem = item;
        Object.keys(item).forEach(function (key) {
          var regexp = new RegExp('^classtype', 'igm');

          if (regexp.test(key) && item[key]) {
            treeList.push(item[key]);
          }
        });
      } // console.log(treeList)


      this.setState({
        treeList: treeList,
        activeKey: activeKey,
        activeItem: activeItem
      });
    }
  }, {
    key: "onTreeSelectChange",
    value: function onTreeSelectChange(item, index, value, label, extra) {
      var _this2 = this;

      var treeList = JSON.parse(JSON.stringify(this.state.treeList));
      treeList[index] = _extends(item, {
        value: value
      });
      this.setState({
        treeList: treeList
      }, function () {
        if (value) {
          var str = ' cmapping("' + _this2.state.activeItem.code + '/' + _this2.state.activeItem.name + '","' + _this2.state.activeItem.id + '","' + extra.triggerNode.props.code + '") ';

          _this2.props.onInsertValue(str);

          _this2.props.onDesc('cmapping');
        }
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var DocumentTreeData = this.props.DocumentTreeData; // let value = this.state.value

      console.log(DocumentTreeData);

      var loop = function loop(data) {
        // console.log(data)
        return data.map(function (item) {
          // let isflag = false
          // if(value && value.length > 0){
          //   let reg = new RegExp(value,'igm')
          //   isflag = reg.test(item.title)
          //   // console.log(isflag)
          // }else{
          //   // console.log(isflag)
          // }
          if (item.children && item.children.length > 0) {
            return _react["default"].createElement(_rcTreeSelect.TreeNode, {
              title: item.title,
              isLeaf: false,
              key: item.key,
              code: item.code,
              disabled: item.disabled,
              value: item.title // className={isflag ? 'yy-search-selected' : ''}

            }, loop(item.children));
          } else {
            return _react["default"].createElement(_rcTreeSelect.TreeNode, {
              title: item.title,
              isLeaf: true,
              key: item.key,
              code: item.code,
              disabled: item.disabled,
              value: item.title // className={isflag ? 'yy-search-selected' : ''}

            });
          }
        });
      };

      return _react["default"].createElement("div", {
        className: "yy-tab-content"
      }, _react["default"].createElement("form", {
        className: "form-inline"
      }, _react["default"].createElement("span", null, "\u5B9A\u4F4D\uFF1A"), _react["default"].createElement("div", {
        className: "form-group"
      }, _react["default"].createElement("input", {
        className: "form-control",
        onChange: this.onChange,
        value: this.state.value
      }))), _react["default"].createElement("div", null, _react["default"].createElement("ul", {
        className: "nav nav-pills nav-stacked"
      }, this.props.SubjectData.map(function (item) {
        var flag = false;

        if (_this3.state.value && _this3.state.value.length > 0) {
          var regexp = new RegExp(_this3.state.value, 'igm');

          if (regexp.test(item.code + '' + item.name)) {
            flag = true;
          }
        }

        var className = _this3.state.activeKey == item.id ? 'active' : '';
        className = className + (flag ? ' subject-search' : '');
        return _react["default"].createElement("li", {
          onClick: _this3.onClick.bind(_this3, item),
          className: className,
          key: item.id
        }, _react["default"].createElement("a", {
          href: "javascript:void(0)"
        }, item.code, " / ", item.name));
      }))), _react["default"].createElement("hr", null), _react["default"].createElement("form", {
        className: "form-horizontal"
      }, this.state.treeList.map(function (item, index) {
        return _react["default"].createElement("div", {
          key: item.id,
          className: "form-group"
        }, _react["default"].createElement("label", {
          className: "col-sm-2 control-label"
        }, item.name), _react["default"].createElement("div", {
          className: "col-sm-10"
        }, _react["default"].createElement(_rcTreeSelect["default"], {
          showSearch: true,
          showLine: true,
          style: {
            width: '100%'
          },
          value: item.value,
          dropdownStyle: {
            maxHeight: 300,
            overflow: 'auto'
          },
          placeholder: "\u8BF7\u8F93\u5165...",
          notFoundContent: "\u6682\u65E0\u6570\u636E",
          allowClear: true,
          treeDefaultExpandAll: true,
          onChange: _this3.onTreeSelectChange.bind(_this3, item, index)
        }, loop(DocumentTreeData))));
      })));
    }
  }]);

  return SubjectComponents;
}(_react["default"].Component);

SubjectComponents.propTypes = {
  item: _propTypes["default"].object
};
SubjectComponents.defaultProps = {
  item: {}
};
(0, _reactLifecyclesCompat.polyfill)(SubjectComponents);
var _default = SubjectComponents;
exports["default"] = _default;